
(* 
 * This is not a complete list of combinators - not even close.
 * These are just two major collections of Turing complete ones.
 *)




(* The S K (and I) combinators *)

(*
 * S : ('a -> 'b -> 'c) -> ('a -> 'b) -> 'a -> 'c
 * REQUIRES: true
 * ENSURES: S f g x =~ f x (g x)
 *)
fun S (f:'a -> 'b -> 'c) (g:'a -> 'b) (x:'a) : 'c =
  f x (g x)
  (* B (B W) (B B C) *)

(*
 * K : 'a -> 'b -> 'a
 * REQUIRES: true
 * ENSURES: K x y =~ x; 
 *  K is the curried first projection
 *)
fun K (x:'a) (y:'b) : 'a = 
  x

(*
 * I : 'a -> 'a
 * REQUIRES: true
 * ENSURES: I x =~ x; 
 *  I is identity
 *)
fun I (x:'a) : 'a = 
  x 
  (* S K K *)
  (* W K *)






(* The B C K W combinators (K is above) *)

(*
 * B : ('a -> 'b) -> ('c -> 'a) -> 'c -> 'b
 * REQUIRES: true
 * ENSURES: B f g x =~ f (g x); 
 *  B is compose (o)
 *)
fun B (f:'a -> 'b) (g:'c -> 'a) (x:'c) : 'b = 
  f (g x)
  (* S (K S) K *)


(*
 * C : 'a -> ('a -> 'b) -> 'b
 * REQUIRES: true
 * ENSURES: C x y = y x; 
 *  C is pipe (|>)
 *) 
fun C (x:'a) (y:'a -> 'b) : 'b =
  y x 
  (* S (S (K (S (K S) K)) S) (K K) *)

(*
 * W : ('a -> 'a -> 'b) -> 'a -> 'b
 * REQUIRES: true
 * ENSURES: W x y = x y y 
 *)
fun W (x:'a -> 'a -> 'b) (y:'a) : 'b =
  x y y
  (* S S (S K) *)

