
(*
 * exp : int * int -> int
 * REQUIRES: k >= 0
 * ENSURES: exp (k, n) ==> n^k (where 0^0 is 1)
 *)
fun exp (k:int, n:int) : int =
  if k = 0 
  then 1
  else n * exp (k-1, n)



(*
 * curriedExp : int -> int -> int
 * REQUIRES: k >= 0
 * ENSURES: curriedExp k n ==> n^k (where 0^0 is 1)
 *)
fun curriedExp (k:int) (n:int) : int =
  if k = 0 
  then 1
  else n * curriedExp (k-1) n



(*
 * stagedExp: int -> int -> int
 * REQUIRES: k >= 
 * ENSURES: stagedExp k n ==> n^k (where 0^0 is 1)
 *)
fun stagedExp (k:int) : int -> int = 
  if k = 0
  then fn n => 1 
  else 
    let 
      val prev = stagedExp (k-1)
    in 
      fn n => n * prev n
    end