

(* 
 * ++ : ('a -> int) * ('a -> int) -> 'a -> int
 * REQUIRES: true
 * ENSURES (f ++ g) x =~ (f x) + (g x)
 *)
infixr ++
fun ((f:'a -> int) ++ (g:'a -> int)) (x : 'a) : int = 
  f x + g x


(* 
 * -- : ('a -> int) * ('a -> int) -> 'a -> int
 * REQUIRES: true
 * ENSURES (f ++ g) x =~ (f x) - (g x)
 *)
infixr --
fun ((f:'a -> int) -- (g:'a -> int)) (x : 'a) : int = 
  f x - g x


(* 
 * ** : ('a -> int) * ('a -> int) -> 'a -> int
 * REQUIRES: true
 * ENSURES (f ** g) x =~ (f x) + (g x)
 *)
infixr **
fun ((f:'a -> int) ** (g:'a -> int)) (x : 'a) : int = 
  f x * g x


(*
 * pointwise : (int * int -> int) -> ('a -> int) * ('a -> int) -> int
 * REQUIRES: true
 * ENSURES: pointwise f (g, h) x =~ f (g x, h x)
 *)
fun pointwise (f:int * int -> int) (g:'a -> int, h:'a -> int) (x:'a) : int =
  f (g x, h x)



fun pointMin x = pointwise Int.min x


(*
 * polyPointwise : ('a * 'b -> 'c) -> ('d -> 'a) * ('d -> 'b) -> 'd -> 'c
 * REQUIRES: true
 * ENSURES: polyPointwise f (g, h) x =~ f (g x, h x)
 *)
fun polyPointwise (f:'a * 'b -> 'c) (g:'d -> 'a, h:'d -> 'b) (x:'d) : 'c =
  f (g x, h x)