
(*
 * Y : ('a -> 'a) -> 'a
 * REQUIRES: true
 * ENSURES: Y f =~ f (Y f)
 *  note that this will loop forever
 *  and never run f
 *)
fun Y (f:'a -> 'a) : 'a =
  f (Y f)


(*
 * Z : (('a -> 'b) -> 'a -> 'b) -> 'a -> 'b
 * REQUIRES: true
 * ENSURES: Z f x =~ f (Z f) x
 *  Z f x therefore yields the fixpoint of f, applied to x
 *  i.e., Z f gives the fixedpoint of f
 *)
fun Z (f:('a -> 'b) -> 'a -> 'b) (x:'a) : 'b = 
  f (Z f) x


(*
 * fac : int -> int
 * REQUIRES: n >= 0
 * ENSURES fac n ==> n!
 *)
val fac = 
  Z 
    (fn recFun => 
      fn n => 
        if n = 0 
        then 1 
        else n * recFun (n-1)
    )


val 1 = fac 0 
val 2 = fac 2 
val 24 = fac 4